#ifndef _SIMPLICIAL_COMPLEX_ITERATOR_H_
#define _SIMPLICIAL_COMPLEX_ITERATOR_H_


//////////////////////////////////////////////////////////////////////////////
// Includes


//////////////////////////////////////////////////////////////////////////////
// class SimplexIterator
//

template<typename T>
class SimplexIterator
{
public:  // methods
    SimplexIterator( const SimplicialComplex<3> *sc );
    ~SimplexIterator() {}

    SimplexIterator& operator++();
    SimplexIterator operator++(int);

    const T& operator*() const;
    const T* operator->() const;

    operator bool() const;

private:  // methods
    SimplexIterator();

private:  // data
    T m_simplex;
};


template<typename T>
inline SimplexIterator<T>::SimplexIterator( const SimplicialComplex<3> *sc ) : m_simplex(sc,0)
{
    // empty
}

template<typename T>
inline SimplexIterator<T>& SimplexIterator<T>::operator++()
{
    ++m_simplex.index;
    return (*this);
}

template<typename T>
inline SimplexIterator<T> SimplexIterator<T>::operator++(int)
{
    SimplexIterator<T> iterator = *this;
    ++(*this);
    return iterator;
}

template<typename T>
inline const T& SimplexIterator<T>::operator*() const
{
    return m_simplex;
}

template<typename T>
inline const T* SimplexIterator<T>::operator->() const
{
    return &m_simplex;
}

template<typename T>
inline SimplexIterator<T>::operator bool() const
{
    return (bool)m_simplex;
}


#endif  // _SIMPLICIAL_COMPLEX_ITERATOR_H_
